(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ng-expandable-input/cdk'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@ng-expandable-input/bootstrap', ['exports', '@angular/core', '@ng-expandable-input/cdk', '@angular/common'], factory) :
    (global = global || self, factory((global['ng-expandable-input'] = global['ng-expandable-input'] || {}, global['ng-expandable-input'].bootstrap = {}), global.ng.core, global.cdk, global.ng.common));
}(this, function (exports, core, cdk, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExpInputBootstrapDirective = /** @class */ (function () {
        function ExpInputBootstrapDirective() {
        }
        ExpInputBootstrapDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[btsExpInput]'
                    },] }
        ];
        return ExpInputBootstrapDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExpIconCloseBootstrapDirective = /** @class */ (function () {
        function ExpIconCloseBootstrapDirective() {
        }
        ExpIconCloseBootstrapDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[btsExpIconClose]'
                    },] }
        ];
        return ExpIconCloseBootstrapDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExpIconOpenBootstrapDirective = /** @class */ (function () {
        function ExpIconOpenBootstrapDirective() {
        }
        ExpIconOpenBootstrapDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[btsExpIconOpen]'
                    },] }
        ];
        return ExpIconOpenBootstrapDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExpandableInputBootstrapComponent = /** @class */ (function () {
        function ExpandableInputBootstrapComponent() {
            this.isAbsolute = false;
            this.right = 0;
            this.slideToEdge = false;
            this.isOpen = false;
        }
        /**
         * @return {?}
         */
        ExpandableInputBootstrapComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.sanityCheck();
        };
        /**
         * @return {?}
         */
        ExpandableInputBootstrapComponent.prototype.opened = /**
         * @return {?}
         */
        function () {
            this.isOpen = true;
        };
        /**
         * @return {?}
         */
        ExpandableInputBootstrapComponent.prototype.closed = /**
         * @return {?}
         */
        function () {
            this.isOpen = false;
        };
        /**
         * @private
         * @return {?}
         */
        ExpandableInputBootstrapComponent.prototype.sanityCheck = /**
         * @private
         * @return {?}
         */
        function () {
            if (!this.expandableInputRef) {
                throw new cdk.ExpInputError('You need to include an element with attribute btsExpInput');
            }
            if (!this.iconOpen) {
                throw new cdk.ExpInputError('You need to include an element with attribute btsExpIconOpen');
            }
        };
        ExpandableInputBootstrapComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bts-expandable-input',
                        template: "<cdk-expandable-input\r\n  [group]=\"group\"\r\n  [isAbsolute]=\"isAbsolute\"\r\n  [right]=\"right\"\r\n  [slideToEdge]=\"slideToEdge\"\r\n  [actionOffset]=\"9\"\r\n  [openOnKey]=\"openOnKey\"\r\n  (opened)=\"opened()\"\r\n  (closed)=\"closed()\"\r\n>\r\n  <div cdkExpInput>\r\n    <ng-content select=\"[btsExpInput]\"></ng-content>\r\n  </div>\r\n\r\n  <div cdkExpIconOpen>\r\n    <ng-content select=\"[btsExpIconOpen]\"></ng-content>\r\n  </div>\r\n  \r\n  <div cdkExpIconAction>\r\n    <ng-content select=\"[btsExpIconAction]\"></ng-content>\r\n  </div>\r\n  \r\n  <div cdkExpIconClose *ngIf=\"iconClose; else defaultIconClose\">\r\n    <ng-content select=\"[btsExpIconClose]\"></ng-content>\r\n  </div>\r\n\r\n  <ng-template #defaultIconClose>\r\n    <i cdkExpIconClose class=\"fas fa-times\"></i>\r\n  </ng-template>\r\n</cdk-expandable-input>\r\n",
                        styles: ["cdk-expandable-input{background-color:#fff}cdk-expandable-input::ng-deep .input-field{height:44px!important}cdk-expandable-input::ng-deep .input-field [cdkExpInput]{left:3px;top:3px;width:calc(100% - 8px)}"]
                    }] }
        ];
        ExpandableInputBootstrapComponent.propDecorators = {
            group: [{ type: core.Input }],
            isAbsolute: [{ type: core.Input }],
            right: [{ type: core.Input }],
            slideToEdge: [{ type: core.Input }],
            openOnKey: [{ type: core.Input }],
            cdk: [{ type: core.ViewChild, args: [cdk.CdkExpandableInputComponent, { static: false },] }],
            expandableInputRef: [{ type: core.ContentChild, args: [ExpInputBootstrapDirective, { read: core.ElementRef, static: true },] }],
            iconClose: [{ type: core.ContentChild, args: [ExpIconCloseBootstrapDirective, { read: core.ElementRef, static: true },] }],
            iconOpen: [{ type: core.ContentChild, args: [ExpIconOpenBootstrapDirective, { read: core.ElementRef, static: true },] }]
        };
        return ExpandableInputBootstrapComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExpandableInputBootstrapModule = /** @class */ (function () {
        function ExpandableInputBootstrapModule() {
        }
        ExpandableInputBootstrapModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            cdk.ExpandableInputModule
                        ],
                        declarations: [
                            ExpandableInputBootstrapComponent,
                            ExpInputBootstrapDirective,
                            ExpIconOpenBootstrapDirective,
                            ExpIconCloseBootstrapDirective
                        ],
                        exports: [
                            cdk.ExpandableInputModule,
                            ExpandableInputBootstrapComponent,
                            ExpInputBootstrapDirective,
                            ExpIconOpenBootstrapDirective,
                            ExpIconCloseBootstrapDirective
                        ]
                    },] }
        ];
        return ExpandableInputBootstrapModule;
    }());

    exports.ExpIconCloseBootstrapDirective = ExpIconCloseBootstrapDirective;
    exports.ExpIconOpenBootstrapDirective = ExpIconOpenBootstrapDirective;
    exports.ExpInputBootstrapDirective = ExpInputBootstrapDirective;
    exports.ExpandableInputBootstrapComponent = ExpandableInputBootstrapComponent;
    exports.ExpandableInputBootstrapModule = ExpandableInputBootstrapModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-expandable-input-bootstrap.umd.js.map
