import { Directive, Component, Input, ViewChild, ContentChild, ElementRef, NgModule } from '@angular/core';
import { ExpInputError, CdkExpandableInputComponent, ExpandableInputModule } from '@ng-expandable-input/cdk';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ExpInputBootstrapDirective {
}
ExpInputBootstrapDirective.decorators = [
    { type: Directive, args: [{
                selector: '[btsExpInput]'
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ExpIconCloseBootstrapDirective {
}
ExpIconCloseBootstrapDirective.decorators = [
    { type: Directive, args: [{
                selector: '[btsExpIconClose]'
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ExpIconOpenBootstrapDirective {
}
ExpIconOpenBootstrapDirective.decorators = [
    { type: Directive, args: [{
                selector: '[btsExpIconOpen]'
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ExpandableInputBootstrapComponent {
    constructor() {
        this.isAbsolute = false;
        this.right = 0;
        this.slideToEdge = false;
        this.isOpen = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.sanityCheck();
    }
    /**
     * @return {?}
     */
    opened() {
        this.isOpen = true;
    }
    /**
     * @return {?}
     */
    closed() {
        this.isOpen = false;
    }
    /**
     * @private
     * @return {?}
     */
    sanityCheck() {
        if (!this.expandableInputRef) {
            throw new ExpInputError('You need to include an element with attribute btsExpInput');
        }
        if (!this.iconOpen) {
            throw new ExpInputError('You need to include an element with attribute btsExpIconOpen');
        }
    }
}
ExpandableInputBootstrapComponent.decorators = [
    { type: Component, args: [{
                selector: 'bts-expandable-input',
                template: "<cdk-expandable-input\r\n  [group]=\"group\"\r\n  [isAbsolute]=\"isAbsolute\"\r\n  [right]=\"right\"\r\n  [slideToEdge]=\"slideToEdge\"\r\n  [actionOffset]=\"9\"\r\n  [openOnKey]=\"openOnKey\"\r\n  (opened)=\"opened()\"\r\n  (closed)=\"closed()\"\r\n>\r\n  <div cdkExpInput>\r\n    <ng-content select=\"[btsExpInput]\"></ng-content>\r\n  </div>\r\n\r\n  <div cdkExpIconOpen>\r\n    <ng-content select=\"[btsExpIconOpen]\"></ng-content>\r\n  </div>\r\n  \r\n  <div cdkExpIconAction>\r\n    <ng-content select=\"[btsExpIconAction]\"></ng-content>\r\n  </div>\r\n  \r\n  <div cdkExpIconClose *ngIf=\"iconClose; else defaultIconClose\">\r\n    <ng-content select=\"[btsExpIconClose]\"></ng-content>\r\n  </div>\r\n\r\n  <ng-template #defaultIconClose>\r\n    <i cdkExpIconClose class=\"fas fa-times\"></i>\r\n  </ng-template>\r\n</cdk-expandable-input>\r\n",
                styles: ["cdk-expandable-input{background-color:#fff}cdk-expandable-input::ng-deep .input-field{height:44px!important}cdk-expandable-input::ng-deep .input-field [cdkExpInput]{left:3px;top:3px;width:calc(100% - 8px)}"]
            }] }
];
ExpandableInputBootstrapComponent.propDecorators = {
    group: [{ type: Input }],
    isAbsolute: [{ type: Input }],
    right: [{ type: Input }],
    slideToEdge: [{ type: Input }],
    openOnKey: [{ type: Input }],
    cdk: [{ type: ViewChild, args: [CdkExpandableInputComponent, { static: false },] }],
    expandableInputRef: [{ type: ContentChild, args: [ExpInputBootstrapDirective, { read: ElementRef, static: true },] }],
    iconClose: [{ type: ContentChild, args: [ExpIconCloseBootstrapDirective, { read: ElementRef, static: true },] }],
    iconOpen: [{ type: ContentChild, args: [ExpIconOpenBootstrapDirective, { read: ElementRef, static: true },] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ExpandableInputBootstrapModule {
}
ExpandableInputBootstrapModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    ExpandableInputModule
                ],
                declarations: [
                    ExpandableInputBootstrapComponent,
                    ExpInputBootstrapDirective,
                    ExpIconOpenBootstrapDirective,
                    ExpIconCloseBootstrapDirective
                ],
                exports: [
                    ExpandableInputModule,
                    ExpandableInputBootstrapComponent,
                    ExpInputBootstrapDirective,
                    ExpIconOpenBootstrapDirective,
                    ExpIconCloseBootstrapDirective
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ExpIconCloseBootstrapDirective, ExpIconOpenBootstrapDirective, ExpInputBootstrapDirective, ExpandableInputBootstrapComponent, ExpandableInputBootstrapModule };
//# sourceMappingURL=ng-expandable-input-bootstrap.js.map
